#include "AT24Cxx.h"

void EEPROM_WriteAbyte(u8 addrH,u8 addrL, u8 dat) 
{
	I2C_Start();							// ʼź
	I2C_WriteAbyte(SLAW);			// ʹ豸ַ+д
	I2C_Check_ACK(); 					// ȴӦ
	I2C_WriteAbyte(addrH);		// д洢ַ8λ
	I2C_Check_ACK(); 					// ȴӦ
	I2C_WriteAbyte(addrL);		// д洢ַ8λ
	I2C_Check_ACK(); 					// ȴӦ
	I2C_WriteAbyte(dat);			// д1ֽ
	I2C_Check_ACK(); 					// ȴӦ
	I2C_Stop();								// ͽź
}

u8 EEPROM_ReadAbyte(u8 addrH,u8 addrL)
{
	u8 dat;
	
	I2C_Start();							// ʼź
	I2C_WriteAbyte(SLAW);			// ʹ豸ַ+д
	I2C_Check_ACK(); 					// ȴӦ
	I2C_WriteAbyte(addrH);		// д洢ַ8λ
	I2C_Check_ACK(); 					// ȴӦ
	I2C_WriteAbyte(addrL);		// д洢ַ8λ
	I2C_Check_ACK(); 					// ȴӦ
				
	I2C_Start();							// ʼź
	I2C_WriteAbyte(SLAR);			// ʹ豸ַ+
	I2C_Check_ACK(); 					// ȴӦ
	dat = I2C_ReadAbyte();		// 1ֽ
	S_NoACK();  							// ͷӦź
	I2C_Stop();								// ֹͣź
	return dat;
}

void EEPROM_WriteNbyte(u8 addrH,u8 addrL, u8 *p, u8 number)          /*  WordAddress,1st Data Address,2nd Data Address,Byte lenth   */
                                                            //F0=0,right, F0=1,error
{
    I2C_Start();
    I2C_WriteAbyte(SLAW);
    I2C_Check_ACK();
    if(!F0)
    {
        I2C_WriteAbyte(addrH);
        I2C_Check_ACK();
				I2C_WriteAbyte(addrL);
        I2C_Check_ACK();
        if(!F0)
        {
            do
            {
                I2C_WriteAbyte(*p);     p++;
                I2C_Check_ACK();
                if(F0)  break;
            }
            while(--number);
        }
    }
    I2C_Stop();
}

/****************************/
void EEPROM_ReadNbyte(u8 addrH, u8 addrL, u8 *p, u8 number)       /*  WordAddress,1st Data Address,2nd Data Address,Byte lenth   */
{
    I2C_Start();
    I2C_WriteAbyte(SLAW);
    I2C_Check_ACK();
    if(!F0)
    {
        I2C_WriteAbyte(addrH);
        I2C_Check_ACK();
				I2C_WriteAbyte(addrL);
        I2C_Check_ACK();
        if(!F0)
        {
            I2C_Start();
            I2C_WriteAbyte(SLAR);
            I2C_Check_ACK();
            if(!F0)
            {
                do
                {
                    *p = I2C_ReadAbyte();   p++;
                    if(number != 1)     S_ACK();    //send ACK
                }
                while(--number);
                S_NoACK();          //send no ACK
            }
        }
    }
    I2C_Stop();
}
//===========================д1ֽں===úֻ1K 2K EEPROMAT24C01AT24C02============================
/*
void EEPROM_WriteAbyte(u8 addr, u8 dat) 
{
	I2C_Start();							// ʼź
	I2C_WriteAbyte(SLAW);			// ʹ豸ַ+д
	I2C_Check_ACK(); 					// ȴӦ
	I2C_WriteAbyte(addr);			// д洢ַ
	I2C_Check_ACK(); 					// ȴӦ
	I2C_WriteAbyte(dat);			// д1ֽ
	I2C_Check_ACK(); 					// ȴӦ
	I2C_Stop();								// ͽź
}
*/
//=====================================================================================================================
//===========================ȡ1ֽں===úֻ1K 2K EEPROMAT24C01AT24C02============================
/*
u8 EEPROM_ReadAbyte(u8 addr)
{
	u8 dat;
	
	I2C_Start();							// ʼź
	I2C_WriteAbyte(SLAW);			// ʹ豸ַ+д
	I2C_Check_ACK(); 					// ȴӦ
	I2C_WriteAbyte(addr);		// д洢ַ
	I2C_Check_ACK(); 					// ȴӦ
				
	I2C_Start();							// ʼź
	I2C_WriteAbyte(SLAR);			// ʹ豸ַ+
	I2C_Check_ACK(); 					// ȴӦ
	dat = I2C_ReadAbyte();		// 1ֽ
	S_NoACK();  							// ͷӦź
	I2C_Stop();								// ֹͣź
	return dat;
}
*/
//=======================================================================================================================
//===========================ֽд뺯===úֻ1K 2K EEPROMAT24C01AT24C02============================
/*
void EEPROM_WriteNbyte(u8 addr, u8 *p, u8 number)          //  WordAddress,First Data Address,Byte lenth 
                                                            //F0=0,right, F0=1,error
{
    I2C_Start();
    I2C_WriteAbyte(SLAW);
    I2C_Check_ACK();
    if(!F0)
    {
        I2C_WriteAbyte(addr);
        I2C_Check_ACK();
        if(!F0)
        {
            do
            {
                I2C_WriteAbyte(*p);     p++;
                I2C_Check_ACK();
                if(F0)  break;
            }
            while(--number);
        }
    }
    I2C_Stop();
}
*/
//=======================================================================================================================
//============================ֽڶȡ===úֻ1K 2K EEPROMAT24C01AT24C02============================
/*
void EEPROM_ReadNbyte(u8 addr, u8 *p, u8 number)       //  WordAddress,First Data Address,Byte lenth 
{
    I2C_Start();
    I2C_WriteAbyte(SLAW);
    I2C_Check_ACK();
    if(!F0)
    {
        I2C_WriteAbyte(addr);
        I2C_Check_ACK();
        if(!F0)
        {
            I2C_Start();
            I2C_WriteAbyte(SLAR);
            I2C_Check_ACK();
            if(!F0)
            {
                do
                {
                    *p = I2C_ReadAbyte();   p++;
                    if(number != 1)     S_ACK();    //send ACK
                }
                while(--number);
                S_NoACK();          //send no ACK
            }
        }
    }
    I2C_Stop();
}
*/
//========================================================================================================================